import { Animated } from 'react-native';
import React from 'react';

type ToastType = "success" | "error" | "info" | "warning";
interface ToastConfig {
    title: string;
    description?: string;
    type?: ToastType;
    duration?: number;
    position?: "top" | "bottom";
}
interface ToastProps {
    title: string;
    description?: string;
    type: ToastType;
    fadeAnim: Animated.Value;
    slideAnim: Animated.Value;
    onDismiss: () => void;
}

declare const Toast: React.FC<ToastProps>;

declare function showToast(config: ToastConfig): void;
declare const ToastRoot: React.FC;

export { Toast, type ToastConfig, type ToastProps, ToastRoot, type ToastType, showToast };
